import mne
import os
import numpy as np


data_path = os.path.expanduser("C:/Users/oledr/Desktop/Sleep Data 128ch") # REM from onedrive  s0129-Only-REM
raw_fname = os.path.join(data_path,'s0129sleep.bdf')# Activetwo2.bdf s0129sleep.bdf s0237sleep.bdf   namelist[0]
raw = mne.io.read_raw_bdf(raw_fname, preload=False) # False
sfreq = raw.info['sfreq']


######    Get events from file
event_new_fname = 'C:/Users/oledr/Desktop/Sleep Data 128ch/s129_EMs_dir_-21_80ms_14uV_psd_10s-eve.fif'
events_from_file = mne.read_events(event_new_fname)
event = events_from_file

# tmin,tmax = -8,9
# epochs = mne.Epochs(raw,events=event,tmin=tmin,tmax=tmax,preload=True)
# low_freq,high_freq = 0.2,60
# epochs.filter(low_freq,high_freq)#,filter_length=500)
# mne.filter.notch_filter(epochs,sfreq,50)
# evoked = epochs.average()
# #evoked.crop(tmin=-0.2,tmax=0.5)
# evoked.plot()
#
# name = 's129-evoked.fif'
# fname_evoked = 'C:/Users/oledr/Desktop/Sleep Data 128ch/Evoked files/' + name
# evoked.save(fname_evoked)


EOG_l_channel_name = 'EOG-l'   # 'EOG-l'  'EXG7'
EOG_r_channel_name = 'EOG-r'  # 'EOG-r'  'EXG8'
raw.pick_channels([EOG_l_channel_name])
raw.load_data()

##### Add EM channel
stim_data = np.zeros((1, len(raw.times)))
info = mne.create_info(['EM'], sfreq, ['stim'])
stim_raw = mne.io.RawArray(stim_data, info)
raw.add_channels([stim_raw], force_update_info=True)
raw.add_events(event,'EM')
raw.pick_channels(['EM'])

# raw.plot(events=event)

##### Save Raw
fname_rem = 'C:/Users/oledr/Desktop/Sleep Data 128ch/EM channel only/s0237sleep-only-EM-channel.fif'
raw.save(fname_rem)